MFClient (3.14.0 600 API)
Date: 2025-11-24

com.marketfactory.api

## Class MFClient

- java.lang.Object
- - com.marketfactory.api.MFClientBase
  - - com.marketfactory.api.MFClient

-     public class MFClient
      extends MFClientBase

  A taker API client, which processes a single network connection. There may be more than one client instance, one for each network connection. A client dispatches callbacks on a _handler interface which the client implements. @see MFHandler.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.marketfactory.api.MFClientBase

      `MFClientBase.OrderArgs, MFClientBase.PingTime, MFClientBase.RiskLimit, MFClientBase.RiskMarketPosition, MFClientBase.RiskUsage, MFClientBase.TimeStats`

  - ### Field Summary

    - ### Fields inherited from class com.marketfactory.api.MFClientBase

      `_riskLimits, _riskTimestamp, _riskUsages, _tradeLimitDataQueue, _userGroupChains, FEED_ALL, FEED_NULL, MARKET_ALL, SETTL_DATE_CASH, SETTL_DATE_SUM`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MFClient(java.lang.String _username, java.lang.String _password, java.lang.String _hostname1, int _port1)` Create a new client object.
    `MFClient(java.lang.String _username, java.lang.String _password, java.lang.String _hostname1, int _port1, java.lang.String _hostname2, int _port2)` Create a new client object (with failover).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `APIResult` | `cancelAll(int feedID, java.lang.String cxlID)` Cancel all the orders on a feed.
    `APIResult` | `cancelAll(java.lang.String cxlID)` Cancel all the orders, on all feeds.
    `APIResult` | `cancelOrder(java.lang.String cxlID, long orderID)` Cancel a previously placed order by internal 'orderID'.
    `protected APIResult` | `cancelOrder(java.lang.String cxlID, long orderID, java.lang.String clOrdID)` Cancel a previously placed order by providing both internal 'orderID' and clOrdID.
    `APIResult` | `cancelOrder(java.lang.String cxlID, java.lang.String clOrdID)` Cancel a previously placed order by client order id ('clOrdID').
    `protected MFHandler` | `getHandler()`
    `Pair<APIResult,java.lang.Long>` | `modifyOrder(java.lang.String clOrdID, java.lang.String clNewID, MFFloat amount, MFFloat minAmount, MFFloat price)` Submit modification to an existing order.
    `Pair<APIResult,java.lang.Long>` | `modifyOrder(java.lang.String clOrdID, java.lang.String clNewID, MFFloat amount, MFFloat minAmount, MFFloat price, java.util.List<KeyValue> parameters)`
    `protected void` | `onBatchComplete(int msg, MFClientBase base)`
    `protected void` | `onConnect(MFClientBase base)`
    `protected void` | `onDateRollover(DateRollover msg, MFClientBase base)`
    `protected void` | `onDisconnect(MFClientBase base)`
    `protected void` | `onDropCopy(DropCopy msg, MFClientBase base)`
    `protected void` | `onEventReport(EventReport msg, MFClientBase base)`
    `protected void` | `onHeartbeat(Heartbeat msg, MFClientBase base)`
    `protected void` | `onMarketData(MarketView msg, MFClientBase base)`
    `protected void` | `onOrderCanceled(OrderCanceled msg, MFClientBase base)`
    `protected void` | `onOrderCancelRejected(OrderCancelRejected msg, MFClientBase base)`
    `protected void` | `onOrderDone(OrderDone msg, MFClientBase base)`
    `protected void` | `onOrderReceived(OrderReceived msg, MFClientBase base)`
    `protected void` | `onOrderRejected(OrderRejected msg, MFClientBase base)`
    `protected void` | `onOrderSubmitted(OrderSubmitted msg, MFClientBase base)`
    `protected void` | `onReplayDone(ReplayDone msg, MFClientBase base)`
    `protected void` | `onStart(MFClientBase base)`
    `protected void` | `onStop(MFClientBase base)`
    `protected void` | `onSubscriptionEvent(SubscriptionEvent msg, MFClientBase base)`
    `protected void` | `onTradeCapture(TradeCapture msg, MFClientBase base)`
    `static MFClient` | `open(java.lang.String user, java.lang.String pass, java.lang.String host, int port)` A convenience method which creates a new client object, attempts to connect to Whisperer, and cleans up and throws an exception if we could not connect.
    `static MFClient` | `open(java.lang.String user, java.lang.String pass, java.lang.String _hostname1, int _port1, java.lang.String _hostname2, int _port2)`
    `Pair<APIResult,java.lang.Integer>` | `registerMarketComb(int feedID, int[] marketIds)` Register for a given list of markets on a given feed.
    `APIResult` | `requestSnapshot(int feedID, int marketID)` Request a market data snapshot for the feed and market ID.
    `APIResult` | `run(MFHandler _handler)` Run a loop that will continuously dispatch incoming messages to a _handler implementation.
    `Pair<APIResult,java.lang.Long>` | `submitOrder(java.lang.String clOrdID, int feedID, int marketID, Side side, MFFloat amount, MFFloat price, MFFloat stopPrice, MFFloat maxShowAmt, MFFloat minAmount, OrderType ordType, TimeInForce tif)` Submit an order.
    `Pair<APIResult,java.lang.Long>` | `submitOrder(java.lang.String clOrdID, int feedID, int marketID, Side side, MFFloat amount, MFFloat price, MFFloat stopPrice, MFFloat maxShowAmt, MFFloat minAmount, OrderType ordType, TimeInForce tif, java.lang.String modelID, java.util.ArrayList<KeyValue> parameters)` Submit an order.
    `Pair<APIResult,java.lang.Long>` | `submitOrder(java.lang.String clOrdID, int feedID, int marketID, Side side, MFFloat amount, MFFloat price, MFFloat stopPrice, MFFloat maxShowAmt, OrderType ordType, TimeInForce tif)` Submit an order without minAmount (kept for backward compatibility).
    `Pair<APIResult,java.lang.Long>` | `submitOrder(java.lang.String clOrdID, int feedID, int marketID, Side side, MFFloat amount, MFFloat price, OrderType ordType, TimeInForce tif)` Submit an order.
    `Pair<APIResult,java.lang.Long>` | `submitOrder(java.lang.String clOrdID, int feedID, int marketID, Side side, MFFloat amount, MFFloat price, OrderType ordType, TimeInForce tif, MFClientBase.OrderArgs args)` Submit an order.
    `APIResult` | `subscribeAllMD()` Subscribe to all the market data feeds.
    `APIResult` | `subscribeMD(int feedID, int marketID)` Subscribe to market data updates for a specific feed.
    `APIResult` | `subscribeMD(int feedID, int marketID, java.lang.String clSubID)` Subscribe to market data updates for a specific feed.
    `APIResult` | `subscribeOF(int feedID)` Subscribe to trading for a specific feed.
    `APIResult` | `subscribeOF(int feedID, java.lang.String clSubID)` Subscribe to trading for a specific feed.
    `APIResult` | `unregisterMarketComb(int batchDefID)` Unregister for a given list of markets on a given feed using the id provided in onBatchEvent callback.
    `APIResult` | `unsubscribeAll()` Unsubscribe all market data and trading subscriptions.
    `APIResult` | `unsubscribeMD(int feedID, int marketID)` Unsubscribe to market data updates for a specific feed.
    `APIResult` | `unsubscribeMD(int feedID, int marketID, java.lang.String clSubID)` Unsubscribe to market data updates for a specific feed.
    `APIResult` | `unsubscribeOF(int feedID)` Unsubscribe to trading for a specific feed.
    `APIResult` | `unsubscribeOF(int feedID, java.lang.String clSubID)` Unsubscribe to trading for a specific feed.

    - ### Methods inherited from class com.marketfactory.api.MFClientBase

      `allowClientsToConnect, close, connect, connectOne, enableDebugMetrics, getFeedByID, getFeedByName, getFeeds, getHostname, getLastPingTimes, getMarketByID, getMarketByName, getPort, getRiskLimits, getRiskMarketPositions, getRiskTimestamp, getRiskUsage, getSequenceID, getSignature, getUserGroupChains, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, handle, init, isConnected, isRunning, isStopRequested, join, lockUser, log, log, modifyOrder, onJsonFromServer, onLockResponse, onMassQuoteAck, onNewOrder, onOrderTimeout, onQuoteRequest, onRiskResponse, onTradeCaptureAck, processEvents, replay, resetAdminMembers, run, send, setDebug, setRisk, setRisk, setRisk, setRisk, setRisk, setStickySubscriptions, setStickySubscriptions, setUseHeartbeat, stop, subscribePricing, subscribeTrading, test, unsubscribePricing, unsubscribeTrading`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MFClient

          public MFClient(java.lang.String _username,
                          java.lang.String _password,
                          java.lang.String _hostname1,
                          int _port1)

      Create a new client object. A new client still needs to be connected (see connect()).
      Parameters:
        `_username` - -- username
        `_password` - -- password
        `_hostname1` - -- primary host
        `_port1` - -- primary port

    - #### MFClient

          public MFClient(java.lang.String _username,
                          java.lang.String _password,
                          java.lang.String _hostname1,
                          int _port1,
                          java.lang.String _hostname2,
                          int _port2)

      Create a new client object (with failover). A new client still needs to be connected (see connect()).
      Parameters:
        `_username` - -- username
        `_password` - -- password
        `_hostname1` - -- primary host
        `_port1` - -- primary port
        `_hostname2` - -- secondary host
        `_port2` - -- secondary port

  - ### Method Detail

    - #### run

          public APIResult run(MFHandler _handler)

      Run a loop that will continuously dispatch incoming messages to a _handler implementation. This method returns some time after a request to stop is made using stop(), or if an error occurs (e.g. the connection is broken). A zero return value indicates a normal exit via a stop request. If the connection is broken and the client succesfully fails over to a secondary server, this dispatcher does not return; onDisconnect() and onConnect() are invoked to let the handler know that this occurred. If the reconnection attempt is not successful, the dispatcher will return an error code. Every call to run() must be preceded by a successful connect() -- this call is made for you, but only once, when a client is obtained via open(). Note: this should not be invoked by _handler.
      Parameters:
        `_handler` - to be run
      Returns:
        run result

    - #### open

          public static MFClient open(java.lang.String user,
                                      java.lang.String pass,
                                      java.lang.String host,
                                      int port)
                               throws java.io.IOException

      A convenience method which creates a new client object, attempts to connect to Whisperer, and cleans up and throws an exception if we could not connect.
      Parameters:
        `user` - -- username
        `pass` - -- password
        `host` - -- primary host
        `port` - -- primary port
      Returns:
        the new client object is returned;
      Throws:
        `java.io.IOException` - -- if connection fails

    - #### open

          public static MFClient open(java.lang.String user,
                                      java.lang.String pass,
                                      java.lang.String _hostname1,
                                      int _port1,
                                      java.lang.String _hostname2,
                                      int _port2)
                               throws java.io.IOException

      Parameters:
        `user` - -- username
        `pass` - -- password
        `_hostname1` - -- primary host
        `_port1` - -- primary port
        `_hostname2` - -- secondary host
        `_port2` - -- secondary port
      Returns:
        A convenience method which creates a new client object, attempts to connect to Whisperer, and cleans up and throws an exception if we could not connect. Otherwise the new client object is returned;
      Throws:
        `java.io.IOException` - -- if connection fails

    - #### subscribeMD

          public APIResult subscribeMD(int feedID,
                                       int marketID,
                                       java.lang.String clSubID)

      Description copied from class: `MFClientBase`
      Subscribe to market data updates for a specific feed. onSubscriptionEvent() will be called to notify that the flow of updates is ready. If the subscription is valid, onMarketData() will be called later on. The client subscription ID allows one-to-one message matching.
      Overrides:
        `subscribeMD` in class `MFClientBase`
      Parameters:
        `feedID` - -- feed id
        `marketID` - -- market id
        `clSubID` - -- client subscription id
      Returns:
        APIResult.OK if the subscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### subscribeMD

          public APIResult subscribeMD(int feedID,
                                       int marketID)

      Description copied from class: `MFClientBase`
      Subscribe to market data updates for a specific feed. onSubscriptionEvent() will be called to notify that the flow of updates is ready. If the subscription is valid, onMarketData() will be called later on.
      Overrides:
        `subscribeMD` in class `MFClientBase`
      Parameters:
        `feedID` - -- feed id
        `marketID` - -- market id
      Returns:
        APIResult.OK if the subscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### subscribeOF

          public APIResult subscribeOF(int feedID,
                                       java.lang.String clSubID)

      Description copied from class: `MFClientBase`
      Subscribe to trading for a specific feed. onSubscriptionEvent() will be called to notify that the order gateway is ready. If the subscription is valid, it will be possible to submit and cancel orders and receive trading events.
      Overrides:
        `subscribeOF` in class `MFClientBase`
      Parameters:
        `feedID` - -- the feed id
        `clSubID` - -- the client subscription id
      Returns:
        APIResult.OK if the subscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### subscribeOF

          public APIResult subscribeOF(int feedID)

      Description copied from class: `MFClientBase`
      Subscribe to trading for a specific feed. onSubscriptionEvent() will be called to notify that the order gateway is ready. If the subscription is valid, it will be possible to submit and cancel orders and receive trading events.
      Overrides:
        `subscribeOF` in class `MFClientBase`
      Parameters:
        `feedID` - -- feed id
      Returns:
        APIResult.OK if the subscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### subscribeAllMD

          public APIResult subscribeAllMD()

      Description copied from class: `MFClientBase`
      Subscribe to all the market data feeds. This is intended as a test utility; ideally you control which feeds and markets you connect to.
      Overrides:
        `subscribeAllMD` in class `MFClientBase`
      Returns:
        APIResult.OK if the subscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### unsubscribeMD

          public APIResult unsubscribeMD(int feedID,
                                         int marketID,
                                         java.lang.String clSubID)

      Description copied from class: `MFClientBase`
      Unsubscribe to market data updates for a specific feed.
      Overrides:
        `unsubscribeMD` in class `MFClientBase`
      Parameters:
        `feedID` - -- feed id
        `marketID` - -- market id
        `clSubID` - -- client subscription id
      Returns:
        APIResult.OK if the unsubscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### unsubscribeMD

          public APIResult unsubscribeMD(int feedID,
                                         int marketID)

      Description copied from class: `MFClientBase`
      Unsubscribe to market data updates for a specific feed.
      Overrides:
        `unsubscribeMD` in class `MFClientBase`
      Parameters:
        `feedID` - -- the feed id
        `marketID` - -- the market id
      Returns:
        APIResult.OK if the unsubscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### unsubscribeOF

          public APIResult unsubscribeOF(int feedID,
                                         java.lang.String clSubID)

      Description copied from class: `MFClientBase`
      Unsubscribe to trading for a specific feed.
      Overrides:
        `unsubscribeOF` in class `MFClientBase`
      Parameters:
        `feedID` - -- the feed id
        `clSubID` - -- the client subscription id
      Returns:
        APIResult.OK if the unsubscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### unsubscribeOF

          public APIResult unsubscribeOF(int feedID)

      Description copied from class: `MFClientBase`
      Unsubscribe to trading for a specific feed.
      Overrides:
        `unsubscribeOF` in class `MFClientBase`
      Parameters:
        `feedID` - -- the feed id
      Returns:
        APIResult.OK if the unsubscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### unsubscribeAll

          public APIResult unsubscribeAll()

      Description copied from class: `MFClientBase`
      Unsubscribe all market data and trading subscriptions. Call this if you want to stop receiving callbacks but don't want to disconnect.
      Overrides:
        `unsubscribeAll` in class `MFClientBase`
      Returns:
        APIResult.OK if the unsubscription request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### registerMarketComb

          public Pair<APIResult,java.lang.Integer> registerMarketComb(int feedID,
                                                                      int[] marketIds)

      Description copied from class: `MFClientBase`
      Register for a given list of markets on a given feed.
      Overrides:
        `registerMarketComb` in class `MFClientBase`
      Parameters:
        `feedID` - -- the feed id
        `marketIds` - -- the list of market ids
      Returns:
        Pair The first member is APIResult.OK if the comb has been registered. The second member is a unique id to identify the market combination.

    - #### unregisterMarketComb

          public APIResult unregisterMarketComb(int batchDefID)

      Description copied from class: `MFClientBase`
      Unregister for a given list of markets on a given feed using the id provided in onBatchEvent callback.
      Overrides:
        `unregisterMarketComb` in class `MFClientBase`
      Parameters:
        `batchDefID` - -- the batch id
      Returns:
        APIResult.OK if the unregistration request has been sent.

    - #### requestSnapshot

          public APIResult requestSnapshot(int feedID,
                                           int marketID)

      Description copied from class: `MFClientBase`
      Request a market data snapshot for the feed and market ID. (Note that after connecting you should get a snapshot automatically, so this should be used rarely.)
      Overrides:
        `requestSnapshot` in class `MFClientBase`
      Parameters:
        `feedID` - -- the feed id
        `marketID` - -- the market id
      Returns:
        APIResult.OK if the snapshot request has been sent, APIResult.SOCKERR_WRITING on error.

    - #### submitOrder

          public Pair<APIResult,java.lang.Long> submitOrder(java.lang.String clOrdID,
                                                            int feedID,
                                                            int marketID,
                                                            Side side,
                                                            MFFloat amount,
                                                            MFFloat price,
                                                            OrderType ordType,
                                                            TimeInForce tif)

      Description copied from class: `MFClientBase`
      Submit an order.
      Overrides:
        `submitOrder` in class `MFClientBase`
      Parameters:
        `clOrdID` - -- client order id
        `feedID` - -- feed id
        `marketID` - -- marketID
        `side` - -- buy or sell
        `amount` - -- order size
        `price` - -- px
        `ordType` - -- order type
        `tif` - -- time in force
      Returns:
        Pair The first member is APIResult.OK if the order has been sent. The second member is the orderID.

    - #### submitOrder

          public Pair<APIResult,java.lang.Long> submitOrder(java.lang.String clOrdID,
                                                            int feedID,
                                                            int marketID,
                                                            Side side,
                                                            MFFloat amount,
                                                            MFFloat price,
                                                            MFFloat stopPrice,
                                                            MFFloat maxShowAmt,
                                                            OrderType ordType,
                                                            TimeInForce tif)

      Description copied from class: `MFClientBase`
      Submit an order without minAmount (kept for backward compatibility).
      Overrides:
        `submitOrder` in class `MFClientBase`
      Parameters:
        `clOrdID` - -- client order id
        `feedID` - -- feed id
        `marketID` - -- marketID
        `side` - -- buy or sell
        `amount` - -- order size
        `price` - -- px
        `stopPrice` - -- stop px
        `maxShowAmt` - -- max show amount
        `ordType` - -- order type
        `tif` - -- time in force
      Returns:
        Pair The first member is APIResult.OK if the order has been sent. The second member is the orderID.

    - #### submitOrder

          public Pair<APIResult,java.lang.Long> submitOrder(java.lang.String clOrdID,
                                                            int feedID,
                                                            int marketID,
                                                            Side side,
                                                            MFFloat amount,
                                                            MFFloat price,
                                                            MFFloat stopPrice,
                                                            MFFloat maxShowAmt,
                                                            MFFloat minAmount,
                                                            OrderType ordType,
                                                            TimeInForce tif)

      Description copied from class: `MFClientBase`
      Submit an order.
      Overrides:
        `submitOrder` in class `MFClientBase`
      Parameters:
        `clOrdID` - -- client order id
        `feedID` - -- feed id
        `marketID` - -- marketID
        `side` - -- buy or sell
        `amount` - -- order size
        `price` - -- px
        `stopPrice` - -- stop px
        `maxShowAmt` - -- max show amount
        `minAmount` - -- minimum amount
        `ordType` - -- order type
        `tif` - -- time in force
      Returns:
        Pair The first member is APIResult.OK if the order has been sent. The second member is the orderID.

    - #### submitOrder

          public Pair<APIResult,java.lang.Long> submitOrder(java.lang.String clOrdID,
                                                            int feedID,
                                                            int marketID,
                                                            Side side,
                                                            MFFloat amount,
                                                            MFFloat price,
                                                            OrderType ordType,
                                                            TimeInForce tif,
                                                            MFClientBase.OrderArgs args)

      Description copied from class: `MFClientBase`
      Submit an order.
      Overrides:
        `submitOrder` in class `MFClientBase`
      Parameters:
        `clOrdID` - -- client order id
        `feedID` - -- feed id
        `marketID` - -- marketID
        `side` - -- buy or sell
        `amount` - -- order size
        `price` - -- px
        `ordType` - -- order type
        `tif` - -- time in force
        `args` - -- additional order parameters
      Returns:
        Pair The first member is APIResult.OK if the order has been sent. The second member is the orderID.

    - #### submitOrder

          public Pair<APIResult,java.lang.Long> submitOrder(java.lang.String clOrdID,
                                                            int feedID,
                                                            int marketID,
                                                            Side side,
                                                            MFFloat amount,
                                                            MFFloat price,
                                                            MFFloat stopPrice,
                                                            MFFloat maxShowAmt,
                                                            MFFloat minAmount,
                                                            OrderType ordType,
                                                            TimeInForce tif,
                                                            java.lang.String modelID,
                                                            java.util.ArrayList<KeyValue> parameters)

      Description copied from class: `MFClientBase`
      Submit an order. Pass in result field to get the result of the operation. This is used so each submitting thread can have its own result without generating garbage
      Overrides:
        `submitOrder` in class `MFClientBase`
      Parameters:
        `clOrdID` - -- client order id
        `feedID` - -- feed id
        `marketID` - -- marketID
        `side` - -- buy or sell
        `amount` - -- order size
        `price` - -- px
        `stopPrice` - -- stop px
        `maxShowAmt` - -- max show amount
        `minAmount` - -- min amount
        `ordType` - -- order type
        `tif` - -- time in force
        `modelID` - -- model
        `parameters` - -- additional parameters
      Returns:
        Pair The first member is APIResult.OK if the order has been sent. The second member is the orderID.

    - #### modifyOrder

          public Pair<APIResult,java.lang.Long> modifyOrder(java.lang.String clOrdID,
                                                            java.lang.String clNewID,
                                                            MFFloat amount,
                                                            MFFloat minAmount,
                                                            MFFloat price)

      Description copied from class: `MFClientBase`
      Submit modification to an existing order.
      Overrides:
        `modifyOrder` in class `MFClientBase`
      Parameters:
        `clOrdID` - -- the client order id to be modified
        `clNewID` - -- the new client order id
        `amount` - -- the amount
        `minAmount` - -- the minimum amount
        `price` - -- px
      Returns:
        Pair The first member is APIResult.OK if the order has been sent. The second member is the orderID.

    - #### modifyOrder

          public Pair<APIResult,java.lang.Long> modifyOrder(java.lang.String clOrdID,
                                                            java.lang.String clNewID,
                                                            MFFloat amount,
                                                            MFFloat minAmount,
                                                            MFFloat price,
                                                            java.util.List<KeyValue> parameters)

      Overrides:
        `modifyOrder` in class `MFClientBase`
      Returns:

    - #### cancelOrder

          public APIResult cancelOrder(java.lang.String cxlID,
                                       java.lang.String clOrdID)

      Description copied from class: `MFClientBase`
      Cancel a previously placed order by client order id ('clOrdID').
      Overrides:
        `cancelOrder` in class `MFClientBase`
      Parameters:
        `cxlID` - -- the cancel id
        `clOrdID` - -- the client order id to be cancelled
      Returns:
        APIResult.INVALID_ORDERID if the order cannot be found locally, i.e., if the 'clOrdID' does not correspond to any previously placed order on this client interface.

    - #### cancelOrder

          public APIResult cancelOrder(java.lang.String cxlID,
                                       long orderID)

      Description copied from class: `MFClientBase`
      Cancel a previously placed order by internal 'orderID'.
      Overrides:
        `cancelOrder` in class `MFClientBase`
      Parameters:
        `cxlID` - -- the cancel id
        `orderID` - -- the order id
      Returns:
        APIResult.INVALID_ORDERID if the internal 'orderID' could not be provided.

    - #### cancelOrder

          protected APIResult cancelOrder(java.lang.String cxlID,
                                          long orderID,
                                          java.lang.String clOrdID)

      Description copied from class: `MFClientBase`
      Cancel a previously placed order by providing both internal 'orderID' and clOrdID. APIResult.INVALID_ORDERID if the internal 'orderID' could not be provided.
      Overrides:
        `cancelOrder` in class `MFClientBase`

    - #### cancelAll

          public APIResult cancelAll(int feedID,
                                     java.lang.String cxlID)

      Description copied from class: `MFClientBase`
      Cancel all the orders on a feed.
      Overrides:
        `cancelAll` in class `MFClientBase`
      Parameters:
        `feedID` - -- the feed id
        `cxlID` - -- the cancel id
      Returns:
        -- the result of sending the message

    - #### cancelAll

          public APIResult cancelAll(java.lang.String cxlID)

      Description copied from class: `MFClientBase`
      Cancel all the orders, on all feeds.
      Overrides:
        `cancelAll` in class `MFClientBase`
      Parameters:
        `cxlID` - -- the cancel id
      Returns:
        -- the result of sending the message

    - #### getHandler

          protected MFHandler getHandler()

    - #### onStart

          protected void onStart(MFClientBase base)

      Overrides:
        `onStart` in class `MFClientBase`

    - #### onStop

          protected void onStop(MFClientBase base)

      Overrides:
        `onStop` in class `MFClientBase`

    - #### onDisconnect

          protected void onDisconnect(MFClientBase base)

      Overrides:
        `onDisconnect` in class `MFClientBase`

    - #### onConnect

          protected void onConnect(MFClientBase base)

      Overrides:
        `onConnect` in class `MFClientBase`

    - #### onHeartbeat

          protected void onHeartbeat(Heartbeat msg,
                                     MFClientBase base)

      Overrides:
        `onHeartbeat` in class `MFClientBase`

    - #### onSubscriptionEvent

          protected void onSubscriptionEvent(SubscriptionEvent msg,
                                             MFClientBase base)

      Overrides:
        `onSubscriptionEvent` in class `MFClientBase`

    - #### onMarketData

          protected void onMarketData(MarketView msg,
                                      MFClientBase base)

      Overrides:
        `onMarketData` in class `MFClientBase`

    - #### onEventReport

          protected void onEventReport(EventReport msg,
                                       MFClientBase base)

      Overrides:
        `onEventReport` in class `MFClientBase`

    - #### onDateRollover

          protected void onDateRollover(DateRollover msg,
                                        MFClientBase base)

      Overrides:
        `onDateRollover` in class `MFClientBase`

    - #### onBatchComplete

          protected void onBatchComplete(int msg,
                                         MFClientBase base)

      Overrides:
        `onBatchComplete` in class `MFClientBase`

    - #### onOrderReceived

          protected void onOrderReceived(OrderReceived msg,
                                         MFClientBase base)

      Overrides:
        `onOrderReceived` in class `MFClientBase`

    - #### onOrderRejected

          protected void onOrderRejected(OrderRejected msg,
                                         MFClientBase base)

      Overrides:
        `onOrderRejected` in class `MFClientBase`

    - #### onOrderSubmitted

          protected void onOrderSubmitted(OrderSubmitted msg,
                                          MFClientBase base)

      Overrides:
        `onOrderSubmitted` in class `MFClientBase`

    - #### onOrderCanceled

          protected void onOrderCanceled(OrderCanceled msg,
                                         MFClientBase base)

      Overrides:
        `onOrderCanceled` in class `MFClientBase`

    - #### onOrderCancelRejected

          protected void onOrderCancelRejected(OrderCancelRejected msg,
                                               MFClientBase base)

      Overrides:
        `onOrderCancelRejected` in class `MFClientBase`

    - #### onTradeCapture

          protected void onTradeCapture(TradeCapture msg,
                                        MFClientBase base)

      Overrides:
        `onTradeCapture` in class `MFClientBase`

    - #### onOrderDone

          protected void onOrderDone(OrderDone msg,
                                     MFClientBase base)

      Overrides:
        `onOrderDone` in class `MFClientBase`

    - #### onDropCopy

          protected void onDropCopy(DropCopy msg,
                                    MFClientBase base)

      Overrides:
        `onDropCopy` in class `MFClientBase`

    - #### onReplayDone

          protected void onReplayDone(ReplayDone msg,
                                      MFClientBase base)

      Overrides:
        `onReplayDone` in class `MFClientBase`